#include <LiquidCrystal_I2C.h>
#include <Wire.h>
#include <SoftwareSerial.h>
#include <SD.h>
#include <TMRpcm.h>

#define BUTTON_0 0
#define BUTTON_1 1
#define BUTTON_2 10

#define miscare_PIN 5
#define cardSD_pin 4


TMRpcm tmrpcm;

#define PIN_RED  A2

#define PIN_GREEN A1

#define PIN_BLUE A0

LiquidCrystal_I2C lcd(0x27, 16, 2);
SoftwareSerial hc06(2, 3);

int check_monitor = 0;
int light = 0;
int atentie_copil = 0;
int mama = 0;
int tata = 0;

void setup() {
  lcd.init();
  lcd.backlight();

  pinMode(BUTTON_0, INPUT_PULLUP);
  pinMode(BUTTON_1, INPUT_PULLUP);
  pinMode(BUTTON_2, INPUT_PULLUP);
  
  pinMode(miscare_PIN, INPUT);
  Serial.begin(9600);
  hc06.begin(9600);

  if (!SD.begin(cardSD_pin)) {
    Serial.println("SD fail");
    return;
  }
  
  tmrpcm.speakerPin = 9; 
  tmrpcm.quality(1);  

  
  pinMode(PIN_RED,   OUTPUT);
  pinMode(PIN_GREEN, OUTPUT);
  pinMode(PIN_BLUE,  OUTPUT);

}



void loop() {
  byte buttonState0 = digitalRead(BUTTON_0);
  byte buttonState1 = digitalRead(BUTTON_1);
  byte buttonState2 = digitalRead(BUTTON_2);
 
  if (buttonState0 == LOW) {
    check_monitor += 1;
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Monitor!");
    delay(1000);
  } else {
    lcd.clear();
  }

   if (buttonState1 == LOW) {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Mami!");
      delay(100); 
      if(mama == 0){
        hc06.println("Mama este chemata! ");
        mama = 1;
      } 
    }else {
    lcd.clear();
    mama = 0;
  }

  if (buttonState2 == LOW) {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Tata!");
      delay(100); 
      if(tata == 0){
        hc06.println("Tata este chemat! ");
        tata = 1;
      } 
    }else {
    lcd.clear();
   tata = 0;
  }
  
  // Serial.println(check_monitor);

  bool isPlaying = false;

  while (check_monitor % 2 != 0) {
    int pirState = digitalRead(miscare_PIN);
  
    // lcd.clear();
    lcd.setCursor(0, 0);  
  
    if (pirState == HIGH) {
      Serial.println("Motion Detected!");
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Parintii vin");
      if (atentie_copil == 0) {
        hc06.println("S-a miscat copilasul! "); 
        atentie_copil = 1;
      }
      light = 1;
    } else {
      Serial.println("No Motion");
      isPlaying = false;
    }
    if(light == 1){
      if (!isPlaying) {
        tmrpcm.play("6.wav");
        tmrpcm.setVolume(10);
        isPlaying = true;
        delay(100);
      }
      analogWrite(PIN_RED,   255);
      analogWrite(PIN_GREEN, 20);
      analogWrite(PIN_BLUE,  147);
      delay(10); 
      
    }

    
    // Verifică starea butonului pentru a ieși din buclă
    buttonState0 = digitalRead(BUTTON_0);
    if (buttonState0 == LOW) {
      analogWrite(PIN_RED, 0);
      analogWrite(PIN_GREEN, 0);
      analogWrite(PIN_BLUE, 0);
      light = 0;
      atentie_copil = 0;
      break;
    }
  
  }
   
}
